# frozen_string_literal: true

require 'active_model'
require 'quby/compiler/services/definition_validator'

module Quby
  module Compiler
    module Entities
      class Definition
        extend  ActiveModel::Naming
        include ActiveModel::Validations

        attr_accessor :key, :sourcecode, :timestamp, :path, :lookup_tables

        def initialize(key:, path:, sourcecode: "", timestamp: nil, lookup_tables: {})
          @path = path
          @key = key
          @sourcecode = sourcecode
          @timestamp = timestamp
          @lookup_tables = lookup_tables
        end

        validates_with Services::DefinitionValidator
      end
    end
  end
end
